#include "TestApp.h"

#include <iostream>
#include <fstream>

TestApp::TestApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin),				// eNX̃RXgN^Ăяo
	tb(argDrawWin, &camera), playerBox(4.0, 4.0, 4.0)	// XggăoϐɏlZbg
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);

	// ̂̐ݒ
	playerModel.setShape(&playerBox);
	playerModel.setMaterial(Cyan);
	playerModel.setSmoothMode(true);
	playerModel.glMoveTo(0.0, 15.0, 0.0);
	playerOBB.setBlockSize(4.0, 4.0, 4.0);
	playerOBB.setModel(&playerModel);

	// effBXvCXgɓo^
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&playerModel);
	// }bṽGg[
	map.entryScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	// V[̃ZbgiX}[gɂˁBBBj
	drawWin->setScene(&scene);

	return;
}

TestApp::~TestApp(void)
{
}

void TestApp::init(void)
{
	return;
}

bool TestApp::procLoop(void)
{
	// J XZ Ƃɐis
	fwdU = camera.getVec();
	fwdU.y = 0.0;
	fwdU.normalize();
	// OςŉEQbg
	fwdR = fwdU ^ fk_Vector(0.0, 1.0, 0.0);

	// Wv̏x XZ ̊x悹
	if(eveMan.getKeyStatus(' ') == FKUT_SW_DOWN) {
		acc.x = spd.x;
		acc.z = spd.z;
		acc.y = 2.0;
	}

	// n㎞͓x^A󒆂ł͉x
	spd.init();
	if(eveMan.getSpecialKeyStatus(FK_UP) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc += fwdU*0.1;
		else spd += fwdU*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_DOWN) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc -= fwdU*0.1;
		else spd -= fwdU*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_LEFT) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc -= fwdR*0.1;
		else spd -= fwdR*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_RIGHT) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc += fwdR*0.1;
		else spd += fwdR*0.5;
	}
	if(spd.normalize()) spd *= 0.5;

	// d͉x
	acc.y -= 0.098;
	if(acc.x*acc.x + acc.z*acc.z > 0.5*0.5) {
		double tmpSpdLen = sqrt(acc.x*acc.x + acc.z*acc.z);
		acc.x *= 0.5/tmpSpdLen;
		acc.z *= 0.5/tmpSpdLen;
	} else {
		acc.x *= 0.9;
		acc.z *= 0.9;
	}

	// x𑬓xɏ悹
	spd += acc;

	// }bv̏Փ˔Ăяo
	if(map.procCollision(&playerOBB, &spd)) {
		// Ԓlbool̏ꍇYɑ΂锽͂Ă̂ŉxNA
		acc.init();
	}
	// ̎_ŏՓ˂̔͂xɉĂ

	// x𑀍샂fɉĎۂɓ
	playerModel.glTranslate(spd);
	camera.glTranslate(spd.x, 0.0, spd.z);
	tb.setLookTo(fk_Vector(playerModel.getPosition().x, 0.0, playerModel.getPosition().z));

	tb.update();

	return true;
}
